#!/usr/bin/perl

# {[[gWX^̒lvZ.
# Usage:
#   perl baud.pl  <CPUClock(Hz)>
#
# U2X=1 iWɕύXĵƂ̃e[uKvȂ
#   CPUclock  24000000 ɂB

my $cpu = 12000000;
my $bps = 300;

my @bpstab=(
     300,
     600,
    1200,
    2400,
    4800,
    9600,
   19200,
   38400,
   57600,
   76800,
  115200,
  230400,
  250000,
  500000,
 1000000,
);

sub print_table()
{
	my ($bps)=@_;

	# {[[gWX^̒lvZ.
    # {[[g P/PUƂČvZ.
	my $ubrr = int( ( $cpu / 16 / $bps ) - 1 );
	my $ubrr_baud = $cpu / 16 / ($ubrr + 1);



	# 덷vZ.
	my $error = (($ubrr_baud / $bps) - 1) * 100;

	printf("%8d %8d %3d %%\n"
		,$bps,$ubrr,$error
	);
}
sub main()
{
	my $i;
	if($ARGV[0]!=0) {
		$cpu = $ARGV[0];
	}
	printf("BaudRate UBRR reg  error %%\n");

	for($i=0;$i<14;$i++) {
		$bps = $bpstab[$i];
		&print_table($bps);
	}
}

&main();


#     300     2499   0 %
#     600     1249   0 %
#    1200      624   0 %
#    2400      311   0 %
#    4800      155   0 %
#    9600       77   0 %
#   19200       38   0 %
#   38400       18   2 %
#   57600       12   0 %
#   76800        8   8 %
#  115200        5   8 %
#  230400        2   8 %
#  250000        2   0 %
#  500000        0  50 %
#

# U2XP̂Ƃ.
#
#BaudRate UBRR reg  error %
#     300     4999   0 %
#     600     2499   0 %
#    1200     1249   0 %
#    2400      624   0 %
#    4800      311   0 %
#    9600      155   0 %
#   19200       77   0 %
#   38400       38   0 %
#   57600       25   0 %
#   76800       18   2 %
#  115200       12   0 %
#  230400        5   8 %
#  250000        5   0 %
#  500000        2   0 %
