/*********************************************************************
 *	菇[: UsbTerm()
 *********************************************************************
 *
 */

#include <stdio.h>
#include <conio.h>
#include <signal.h>

#include <usb.h>

#include "monit.h"
#include "util.h"
#include "term.h"

#define	KEY_ESCAPE_CH 	0x01	// Ctrl+A Ŕ.

/*********************************************************************
 *	
 *********************************************************************
 */
extern	usb_dev_handle *usb_dev; /* the device handle */
extern	int QueryAVR(usb_dev_handle *dev,RxBuf *cmd,uchar *buf);
extern	void Term_Log(int c);
/*********************************************************************
 *	
 *********************************************************************
 */
static unsigned char key_buffer[4];
static char key_count = 0;
static char key_inhibit = 0;

static unsigned char result_buf[8];
static char escape_f;

static FILE *ifp = NULL;
static char upload_f;

/*********************************************************************
 *	Abv[ht@CI[v.
 *********************************************************************
 */
void Open_File(char *fname)
{
	ifp = NULL;
	upload_f = 0;

	if(fname==NULL) return;
	if(fname[0]==0) return;

	ifp = fopen(fname,"rb");	// oCiI[v.
	if(ifp!=NULL) {
		upload_f = 1;			// Abv[h.
	}else{
		printf("FATAL: Can't Open file:%s\n",fname);
	}
}

/*********************************************************************
 *	Abv[ht@CN[Y.
 *********************************************************************
 */
void Close_File()
{
	if( ifp != NULL) {
		fclose(ifp);
		ifp = NULL;
	}
}

/*********************************************************************
 *	Abv[ht@Cf[^o.
 *********************************************************************
 */
int GetFrom_File(char *buf,int siz)
{
	int cnt = fread(buf,1,siz,ifp);
	if( cnt != siz ) {
		upload_f = 0;		//񂩂̓Abv[hf[^͂Ȃ.
	}
	return cnt;
}

/*********************************************************************
 *	Mf[^΁A󎚂.
 *********************************************************************
 */
static void ConPrint_Task(void)
{
	int cnt = result_buf[0] & 7;
	int i;
	for(i=0;i<cnt;i++) {
		Term_Log(result_buf[i+1] );
		putchar( result_buf[i+1] );
	}
}
/*********************************************************************
 *	Mf[^ZbgĂ`uqƒʐM.
 *********************************************************************
 *	ʂresult_buf[8] ɓ.
 */
static void Terminal_Task(void)
{
	RxBuf cmd;
	memset(&cmd,0,sizeof(RxBuf));
	memset(result_buf,0,8);

	cmd.bmRequestType = USB_TYPE_VENDOR | USB_RECIP_DEVICE |USB_ENDPOINT_IN;
	cmd.cmd   = key_count;
	cmd.adr   = key_buffer[0]|( key_buffer[1]<<8 );
	cmd.data0 = key_buffer[2];
	cmd.data1 = key_buffer[3];
	cmd.wlength = 32;

	QueryAVR(usb_dev,&cmd,result_buf);

	key_inhibit = result_buf[0] & 0x80;	// TxBuffer FULL ?
}
/*********************************************************************
 *	R\[ɓ͂΁Akey_bufferɒ߂.
 *********************************************************************
 */
static void KeyInput_Sub(void)
{
	int c;
	key_count = 0;
	if(kbhit()) {
		c = getch();
		if(c == KEY_ESCAPE_CH ) {	// CTRL+A ꂽ.
			escape_f = 1;		// ^[~i[hI.
		}else{
			key_buffer[3] = c;	//̃obt@͉El.
			key_count = 1;
		}
	}
}

/*********************************************************************
 *	Mf[^΁Akey_bufferɒ߂.
 *********************************************************************
 */
static void KeyInput_Task(void)
{
	int cnt,offset;
	char buf[4];
	if( key_inhibit == 0 ) {
		if(	upload_f ) {
			//
			//	Abv[h.
			//
			cnt = GetFrom_File(buf,4);	//t@CSoCg擾.
			offset = (4-cnt);			//key_buffer[]͉El߂Ńf[^.
			memcpy(key_buffer + offset , buf , cnt );
			key_count = cnt;
		}else{
			//
			//	ړ.
			//
			KeyInput_Sub();
		}
	}
}

/*********************************************************************
 *	菇[: Abv[ht@Cw\.
 *********************************************************************
 *  fname NULL󕶎񂾂ꍇ͒ړ͂ɂȂ.
 *  CTRL+A ŒEo.
 *
 */
int UsbTerm(char *fname)
{

	escape_f = 0;			// [[vItO.
	Open_File(fname);

	printf("Entering TerminalMode: Escape=^%c\n", '@' + KEY_ESCAPE_CH );
	signal(SIGINT,SIG_IGN);	// ^C 𖳌ɂ.

	while(1) {
		KeyInput_Task();			//L[.
		if( escape_f ) { break; }	//I.
		Terminal_Task();			//`uqƌM.
		ConPrint_Task();			//R\[o.
	}

	signal(SIGINT,SIG_DFL);
	Close_File();
	return 0;
}

/*********************************************************************
 *
 *********************************************************************
 */

